﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.8
@EndOfDesignText@
Sub Class_Globals
	Private languages As Map
	Private currentLanguage As String
End Sub

Public Sub Initialize()
	languages.Initialize
	LoadTranslations
	currentLanguage = "it" ' Lingua predefinita
End Sub

Private Sub LoadTranslations()
	Dim english As Map = CreateMap( _
	"titolo_applicazione": "Calendar Notes", _
	"oggi": "Today", _
	"gennaio": "January", _
	"febbraio": "February", _
	"marzo": "March", _
	"aprile": "April", _
	"maggio": "May", _
	"giugno": "June", _
	"luglio": "July", _
	"agosto": "August", _
	"settembre": "September", _
	"ottobre": "October", _
	"novembre": "November", _
	"dicembre": "December", _
	"week_lunedi": "Mo", _
	"week_martedi": "Tu", _
	"week_mercoledi": "We", _
	"week_giovedi": "Th", _
	"week_venerdi": "Fr", _
	"week_sabato": "Sa", _
	"week_domenica": "Su", _
	"week_lun_dom" : "Monday-Sunday", _
	"week_dom_sab" : "Sunday-Saturday" _
	)
	
	Dim italian As Map = CreateMap("titolo_applicazione": "Calendario con note", _
	"oggi": "Oggi", _
	"gennaio": "Gennaio", _
	"febbraio": "Febbraio", _
	"marzo": "Marzo", _
	"aprile": "Aprile", _
	"maggio": "Maggio", _
	"giugno": "Giugno", _
	"luglio": "Luglio", _
	"agosto": "Agosto", _
	"settembre": "Settembre", _
	"ottobre": "Ottobre", _
	"novembre": "Novembre", _
	"dicembre": "Dicembre", _
	"week_lunedi": "Lu", _
	"week_martedi": "Ma", _
	"week_mercoledi": "Me", _
	"week_giovedi": "Gi", _
	"week_venerdi": "Ve", _
	"week_sabato": "Sa", _
	"week_domenica": "Do", _
	"week_lun_dom": "Lunedì - Domenica", _
	"week_dom_sab": "Domenica - Sabato" _
	)
    
	languages.Put("en", english)
	languages.Put("it", italian)
End Sub

Public Sub SetLanguage(lang As String)
	If languages.ContainsKey(lang) Then
		currentLanguage = lang
	Else
		Log("Lingua non supportata: " & lang)
	End If
End Sub

Public Sub Translate(key As String) As String

	If languages.Get(currentLanguage).As(Map).ContainsKey(key) Then
		Return languages.Get(currentLanguage).As(Map).Get(key)
	Else
		Return key ' Restituisce la chiave se non trovata
	End If
End Sub