﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
#Event: dayclick, prevclick, nextclick, todayclick
#RaisesSynchronousEvents: dayclick, prevclick, nextclick, todayclick

Sub Class_Globals
	Private xui As XUI
	Private act As Activity	'ignore
	Private mCallback As Object
	Private mEventname As String
	Public lblticks As Long
	Private pnlpicker As Panel
	Public lblseldate As Label
	Public folder As String
	Public rp As RuntimePermissions

	'----------------------------------------------
	' Default colos initializations of the calendar
	'----------------------------------------------
	Public color_month_title As Int = Colors.ARGB(100,182,221,249)
	Public color_week_day_title As Int = Colors.ARGB(100,255,255,135)
	Public color_empty_day As Int = Colors.ARGB(100,230,230,230) 
	Public color_current_day As Int = Colors.ARGB(100,255,50,50)
	Public color_current_day_with_notes As Int = Colors.ARGB(100,255,165,0)
	Public color_day_with_notes As Int = Colors.ARGB(100,255,255,0)
	Public color_weekend As Int = Colors.ARGB(100,255,210,179)
	Public color_working_days As Int = Colors.ARGB(100,158,255,150)
	
	Public color_day_border As Int = Colors.Black
	Public color_day_selected As Int = Colors.Red
	Public color_day_selected_border As Int = Colors.Black
	' Months name
	Public month_january As String = "January"
	Public month_february As String = "February"
	Public month_march As String = "March"
	Public month_april As String = "April"
	Public month_may As String = "May"
	Public month_june As String = "June"
	Public month_july As String = "July"
	Public month_august As String = "August"
	Public month_september As String = "September"
	Public month_october As String = "October"
	Public month_november As String = "November"
	Public month_december As String = "December"
	
	' Days of week name
	Public day_monday As String = "Mo"
	Public day_tuesday As String = "Tu"
	Public day_wednesday As String = "We"
	Public day_thursday As String = "Th"
	Public day_friday As String = "Fr"
	Public day_saturday As String = "Sa"
	Public day_sunday As String = "Su"
End Sub

Public Sub Initialize(Callback As Object, Eventname As String)
	mCallback = Callback
	mEventname = Eventname
	lblseldate.Initialize("")
	folder = rp.GetSafeDirDefaultExternal("")
End Sub

Public Sub set_month_panel(mnth As Int, yr As Int,seq As Int) As Panel
	Private daynumber As Int = 1
	Private	currentticks As Long = DateTime.Now
	Private currentmonth As Int = DateTime.GetMonth(currentticks)
	Private currentyear As Int = DateTime.GetYear(currentticks)
	Private currentday As Int = DateTime.GetDayOfMonth(currentticks)
	Private firstdayticks As Long
	Private leftpos As Int = 0dip
	Private toppos As Int = 0dip
	Dim scale As Float = GetDeviceLayoutValues.Scale
	Dim screensize As Double = GetDeviceLayoutValues.ApproximateScreenSize
	Dim devwidth As Int = GetDeviceLayoutValues.Width/scale
	Dim devheight As Int = (GetDeviceLayoutValues.height/scale) - 40dip	 ' title bar height not included
	If screensize > 8 Then
		Dim devwidth As Int = GetDeviceLayoutValues.Width
		Dim devheight As Int = GetDeviceLayoutValues.height - 80dip	 ' title bar height not included
	End If
	Private boxwidth As Int = DipToCurrent(devwidth/7)
	Private boxheight As Int = DipToCurrent(devheight/8) 'Altezza della casella, mettendo 16 si dimezza
	Private pnl As Panel
	pnl.Initialize("pnl")
	pnl.RemoveAllViews
	firstdayticks = DateUtils.SetDate(yr,mnth,1)
	Private startdaynumber As Int = DateTime.GetDayOfWeek(firstdayticks)	'1 = sunday, 7 = saturday
	' adjust for monday to sunday (seq = 1)
	
	If seq = 1 Then
		If startdaynumber = 1 Then
			startdaynumber = 7
		Else
			startdaynumber = startdaynumber - 1
		End If
	End If
	'
	Private enddaynumber As Int = DateUtils.NumberOfDaysInMonth(mnth,yr)
	Private lstmonthnames As List = Array As String(month_january,month_february,month_march,month_april,month_may,month_june,month_july,month_august,month_september,month_october,month_november,month_december)	
	Private monthname As String = lstmonthnames.Get(mnth-1)
	Private lblmonth As Label = set_label(monthname & " " & yr, color_month_title,"",30)
	lblmonth.Gravity=Gravity.CENTER_VERTICAL & Gravity.CENTER_HORIZONTAL
	pnl.AddView(lblmonth,leftpos,toppos,7*boxwidth,boxheight)
	Private lstdaynames As List
	lstdaynames.Initialize
	
	If seq = 1 Then
		lstdaynames = Array As String(day_monday,day_tuesday,day_wednesday,day_thursday,day_friday,day_saturday,day_sunday)
	Else
		lstdaynames = Array As String(day_sunday,day_monday,day_tuesday,day_wednesday,day_thursday,day_friday,day_saturday)
	End If
	
	For i = 1 To 7
		Private lbl As Label = set_label(lstdaynames.Get(i-1), color_week_day_title,"",16)
		pnl.AddView(lbl,leftpos+boxwidth*(i-1),toppos+boxheight,boxwidth,boxheight)
	Next
	
	For r = 1 To 6
		For c = 1 To 7
			If c < startdaynumber And r = 1 Then
				Private lbl As Label = set_label("",color_empty_day,"",16) ' Colore caselle vuote ad inizio mese
			Else
				If daynumber > enddaynumber Then
					Private lbl As Label = set_label("", color_empty_day,"",16)  ' Colore caselle vuote a fine mese
				Else
					If daynumber = currentday And mnth = currentmonth And yr = currentyear Then
						Private lbl As Label = set_label(daynumber, color_current_day,"lblday",16) ' Colore del giorno corrente
					Else
						' Da domenica a sabato (seq = 2)
						If seq = 2 Then
							If c = 1 Or c = 7 Then
								Private lbl As Label = set_label(daynumber, color_weekend,"lblday",16) ' Colore dei giorni festivi
							Else
								Private lbl As Label = set_label(daynumber,color_working_days,"lblday",16) ' Colore dei giorni lavorativi
							End If
						Else
							' Da lunedì a domenica (seq = 1)
							If c > 5 Then
								Private lbl As Label = set_label(daynumber, color_weekend,"lblday",16) ' Colore dei giorni festivi
							Else
								Private lbl As Label = set_label(daynumber,color_working_days,"lblday",16) ' Colore dei giorni lavorativi
							End If
						End If
					End If
					If File.Exists(folder,DateUtils.SetDate(yr,mnth,daynumber) & "_notes.txt") Then
						If daynumber = currentday And mnth = currentmonth And yr = currentyear Then
							Private lbl As Label = set_label(daynumber,color_current_day_with_notes,"lblday",16) ' Colore giorno corrente con note inserite
						Else
							Private lbl As Label = set_label(daynumber,color_day_with_notes,"lblday",16) ' Colore giorno con note inserite
						End If
					End If
					lbl.Tag = DateUtils.SetDate(yr,mnth,daynumber)
					daynumber = daynumber + 1
				End If
			End If
			pnl.AddView(lbl,leftpos+boxwidth*(c-1),toppos+(boxheight*2)+boxheight*(r-1),boxwidth,boxheight)
		Next
	Next
	pnl.Width = 7 * boxwidth + 1dip
	pnl.Height = 8 * boxheight + 1dip
	Return pnl
End Sub

private Sub set_label(lbltext As String, intbackground As Int, lbltag As String, lblsize As Int) As Label
	Private lbl As Label
	lbl.Initialize(lbltag)
	lbl.Background = set_background(intbackground)
	lbl.Typeface = Typeface.DEFAULT_BOLD
	lbl.TextSize = lblsize
	lbl.Text = lbltext
	lbl.Gravity = Bit.Or(Gravity.CENTER_HORIZONTAL,Gravity.TOP)
	Return lbl
End Sub

Private Sub set_background(intcolor As Int) As StateListDrawable
	Private cd,cd2 As ColorDrawable
	Private sd As StateListDrawable
	cd.Initialize2(intcolor,0,1,color_day_border) 'Colore dei bordi delle caselle
	cd2.Initialize2(color_day_selected,5,1,color_day_selected_border) 'Colore rosso con borso nero quando premo una casella
	sd.Initialize
	sd.AddState(sd.State_Pressed,cd2)
	sd.AddState(sd.State_Enabled,cd)
	Return sd
End Sub

Public Sub lblday_Click
	Dim l As Label = Sender
	lblticks = l.tag
	lblseldate.Text = DateTime.Date(lblticks)
	'Se esiste la funzione cal_dayclick allora la chiamo
	If xui.SubExists(mCallback,mEventname & "_dayclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_dayclick")
	End If
End Sub

Public Sub set_date_picker(intmonth As Int, intyear As Int) As Panel
	pnlpicker.Initialize("pnlpicker")
	pnlpicker.RemoveAllViews
	Private btnprev As Button = set_button("PREV",Colors.ARGB(100,182,221,249),"btnprev")
	pnlpicker.AddView(btnprev,0dip,0dip,70dip,40dip)
	lblseldate = set_label("",Colors.ARGB(100,230,230,230),"",16)
	pnlpicker.AddView(lblseldate,70dip,0dip,148dip,40dip)
	Private btnnext As Button = set_button("NEXT",Colors.ARGB(100,182,221,249),"btnnext")
	pnlpicker.AddView(btnnext,218dip,0dip,70dip,40dip)
	Private pnlmonth As Panel
	pnlmonth.Initialize("pnlmonth")
	pnlmonth = set_month_panel(intmonth,intyear,2)	' su - sa
	Private btntoday As Button = set_button("NOW",Colors.ARGB(100,182,221,249),"btntoday")
	pnlpicker.AddView(btntoday,0dip,40dip,70dip,40dip)
	pnlpicker.AddView(pnlmonth,0dip,40dip,278dip,368dip)
	pnlpicker.SetLayoutAnimated(0dip, 0dip, 0dip, 278dip, 368dip)
	Return pnlpicker
End Sub

Private Sub set_button(btntext As String, intbackground As Int, btntag As String) As Button
	Private btn As Button
	btn.Initialize(btntag)
	btn.Background = set_background(intbackground)
	btn.Typeface = Typeface.DEFAULT_BOLD
	btn.TextSize = 16
	btn.Text = btntext
	btn.Gravity = Bit.Or(Gravity.CENTER_HORIZONTAL,Gravity.CENTER_VERTICAL)
	Return btn
End Sub

Sub btnprev_Click
	If xui.SubExists(mCallback,mEventname & "_btnprevclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btnprevclick")
	End If
End Sub

Sub btnnext_Click
	If xui.SubExists(mCallback,mEventname & "_btnnextclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btnnextclick")
	End If
End Sub

Sub btntoday_Click
	If xui.SubExists(mCallback,mEventname & "_btntodayclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btntodayclick")
	End If
End Sub
